<?php
/**
 * Give Tributes eCards Email Header.
 *
 * @package    Give_Tributes
 * @subpackage Give_Tributes/templates/ecard
 * @author     WordImpress <https://wordimpress.com>
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

// For gmail compatibility, including CSS styles in head/body are stripped out therefore styles need to be inline. These variables contain rules which are added to the template inline. !important; is a gmail hack to prevent styles being stripped if it doesn't like something.
$body               = "
background-color: #f6f6f6;
font-family: 'Helvetica Neue', Helvetica, Arial, 'Lucida Grande', sans-serif;
font-weight: normal;
";
$wrapper            = "
width:100%;
-webkit-text-size-adjust:none !important;
margin:0;
padding: 30px 0 50px 0;
";
$template_container = "
box-shadow:0 0 0 1px #f3f3f3 !important;
border-radius:3px !important;
background-color: #ffffff;
border: 1px solid #e9e9e9;
border-radius:3px !important;
padding: 20px;
";
$template_header    = "
color: #000000;
border-top-left-radius:3px !important;
border-top-right-radius:3px !important;
border-bottom: 0;
font-weight:bold;
line-height:100%;
text-align: center;
vertical-align:middle;
";
$body_content       = "
border-radius:3px !important;
font-family: 'Helvetica Neue', Helvetica, Arial, 'Lucida Grande', sans-serif;
";
$body_content_inner = "
color: #000000;
font-size:14px;
font-family: 'Helvetica Neue', Helvetica, Arial, 'Lucida Grande', sans-serif;
line-height:150%;
text-align:left;
";
$header_content_h1  = "
color: #000000;
margin: 0;
padding: 10px 20px;
display: block;
font-family: 'Helvetica Neue',Helvetica,Arial,'Lucida Grande',sans-serif;
font-size: 28px;
font-weight: 500;
line-height: 1.2;
text-align: left;
";
$header_logo        = "
max-width:450px;
height:auto;
";
$header_graphic     = "
max-width:100%;
height:auto;
";

// Check if using form settings or global.
if ( give_tributes_is_per_form_customized( $form_id ) ) {
	// Per form enabled, use form options.
	$give_tributes_ecard_logo_graphic   = give_get_meta( $form_id, '_give_tributes_per_form_ecards_logo_graphic', true );
	$give_tributes_ecard_header_graphic = give_get_meta( $form_id, '_give_tributes_per_form_ecards_card_graphic', true );
} else {
	// Use global options if not customized per form.
	$give_tributes_ecard_logo_graphic   = give_get_option( 'give_tributes_ecards_logo_graphic' );
	$give_tributes_ecard_header_graphic = give_get_option( 'give_tributes_ecards_card_graphic' );
}
?>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title><?php echo get_bloginfo( 'name' ); ?></title>
</head>
<body leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" offset="0" style="<?php echo $body; ?>">
<div style="<?php echo $wrapper; ?>">
	<table border="0" cellpadding="0" cellspacing="0" height="100%" width="100%">
		<tr>
			<td align="center" valign="top">
				<?php
				if ( ! empty( $give_tributes_ecard_logo_graphic ) ) : ?>
					<div id="give_tributes_ecard_logo_graphic">
						<?php echo '<p style="margin-top:0;"><img src="' . esc_url( $give_tributes_ecard_logo_graphic ) . '" alt="ecard-logo-graphic" style="' . $header_logo . '" /></p>'; ?>
					</div>
				<?php endif; ?>
				<table border="0" cellpadding="0" cellspacing="0" width="600" id="template_container" style="<?php echo $template_container; ?>">
					<tr>
						<td align="center" valign="top">
							<!-- Header -->
							<table border="0" cellpadding="0" cellspacing="0" id="template_header" style="<?php echo $template_header; ?>">
								<tr>
									<td>
										<?php
										if ( ! empty( $give_tributes_ecard_header_graphic ) ) : ?>
											<div id="give_tributes_ecard_header_graphic">
												<?php echo '<p style="margin-top:0;"><img src="' . esc_url( $give_tributes_ecard_header_graphic ) . '" alt="ecard-header-graphic" style="' . $header_graphic . '"  /></p>'; ?>
											</div>
										<?php endif; ?>
									</td>
								</tr>
							</table>
							<!-- End Header -->
						</td>
					</tr>
					<tr>
						<td align="center" valign="top">
							<!-- Body -->
							<table border="0" cellpadding="0" cellspacing="0" width="600" id="template_body">
								<tr>
									<td valign="top" style="<?php echo $body_content; ?>">
										<!-- Content -->
										<table border="0" cellpadding="20" cellspacing="0" width="100%">
											<tr>
												<td valign="top">
													<div style="<?php echo $body_content_inner; ?>">
