<?php
/**
 * Give Tributes Card Sent Notification Template.
 *
 * @package    Give_Tributes
 * @subpackage Give_Tributes/templates/mailCard/notification
 * @author     WordImpress <https://wordimpress.com>
 */

// For gmail compatibility, including CSS styles in head/body are stripped out therefore styles need to be inline. These variables contain rules which are added to the template inline. !important; is a gmail hack to prevent styles being stripped if it doesn't like something.
$body               = "
background-color: #f6f6f6;
font-family: 'Helvetica Neue', Helvetica, Arial, 'Lucida Grande', sans-serif;
font-weight: normal;
";
$wrapper            = "
width:100%;
-webkit-text-size-adjust:none !important;
margin:0;
padding: 30px 0 50px 0;
";
$template_container = "
box-shadow:0 0 0 1px #f3f3f3 !important;
border-radius:3px !important;
background-color: #ffffff;
border: 1px solid #e9e9e9;
border-radius:3px !important;
padding: 20px;
";
$template_header    = "
color: #00000;
border-top-left-radius:3px !important;
border-top-right-radius:3px !important;
border-bottom: 0;
font-weight:bold;
line-height:100%;
text-align: center;
vertical-align:middle;
";
$body_content       = "
border-radius:3px !important;
font-family: 'Helvetica Neue', Helvetica, Arial, 'Lucida Grande', sans-serif;
";
$body_content_inner = "
color: #000000;
font-size:14px;
font-family: 'Helvetica Neue', Helvetica, Arial, 'Lucida Grande', sans-serif;
line-height:150%;
text-align:left;
";
$header_content_h1  = "
color: #000000;
margin: 0;
padding: 10px 20px;
display: block;
font-family: 'Helvetica Neue',Helvetica,Arial,'Lucida Grande',sans-serif;
font-size: 28px;
font-weight: 500;
line-height: 1.2;
text-align: center;
";

$template_footer = "
	border-top:0;
	-webkit-border-radius:3px;
";

$credit     = "
	border:0;
	color: #000000;
	font-family: 'Helvetica Neue', Helvetica, Arial, 'Lucida Grande', sans-serif;
	font-size:12px;
	line-height:125%;
	text-align:center;
";
$header_img = give_get_option( 'email_logo', '' );
$form_id    = give_get_payment_form_id( $payment_id );

// Check if using form settings or global.
if ( give_tributes_is_per_form_customized( $form_id ) ) {
	// Per form enabled, use form options.
	$card_sent_email_heading = give_get_meta( $form_id, '_give_tributes_per_form_card_sent_email_heading', true );
	$card_sent_body          = give_get_meta( $form_id, '_give_tributes_per_form_give_tributes_card_sent_body', true );

} else {
	// Use global options if not customized per form.
	$card_sent_email_heading = give_get_option( 'give_tributes_card_sent_email_heading' );
	$card_sent_body          = give_get_option( 'give_tributes_card_sent_body' );

}

?>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title><?php echo get_bloginfo( 'name' ); ?></title>
</head>
<body leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" offset="0" style="<?php echo $body; ?>">
<div style="<?php echo $wrapper; ?>">
	<table border="0" cellpadding="0" cellspacing="0" height="100%" width="100%">
		<tr>
			<td align="center" valign="top">
				<?php if ( ! empty( $header_img ) ) : ?>
					<div id="template_header_image">
						<?php echo '<p style="margin-top:0;"><img src="' . esc_url( $header_img ) . '" alt="' . get_bloginfo( 'name' ) . '" style="max-width:600px;height:auto;" /></p>'; ?>
					</div>
				<?php endif; ?>
				<table border="0" cellpadding="0" cellspacing="0" width="600" id="template_container" style="<?php echo $template_container; ?>">
					<?php if ( ! empty( $card_sent_email_heading ) ): ?>
						<tr>
							<td align="center" valign="top">
								<!-- Header -->
								<table border="0" cellpadding="0" cellspacing="0" width="600" id="template_header" style="<?php echo $template_header; ?>" bgcolor="#ffffff">
									<tr>
										<td>
											<h1 style="<?php echo $header_content_h1; ?>"><?php echo $card_sent_email_heading; ?></h1>
										</td>
									</tr>
								</table>
								<!-- End Header -->
							</td>
						</tr>
					<?php endif; ?>
					<tr>
						<td align="center" valign="top">
							<!-- Body -->
							<table border="0" cellpadding="0" cellspacing="0" width="600" id="template_body">
								<tr>
									<td valign="top" style="<?php echo $body_content; ?>">
										<!-- Content -->
										<table border="0" cellpadding="20" cellspacing="0" width="100%">
											<tr>
												<td valign="top">
													<div style="<?php echo $body_content_inner; ?>">
														<?php echo give_tribute_do_tags( apply_filters( "give_tributes_mail_card_notification_content", wpautop( $card_sent_body ) ), $payment_id ); ?>
													</div>
												</td>
											</tr>
										</table>
										<!-- End Content -->
									</td>
								</tr>
							</table>
							<!-- End Body -->
						</td>
					</tr>
					<tr>
						<td align="center" valign="top">
							<!-- Footer -->
							<table border="0" cellpadding="10" cellspacing="0" width="600" id="template_footer" style="<?php echo $template_footer; ?>">
								<tr>
									<td valign="top">
										<table border="0" cellpadding="10" cellspacing="0" width="100%">
											<tr>
												<td colspan="2" valign="middle" id="credit" style="<?php echo $credit; ?>">
													<?php echo wpautop( wp_kses_post( wptexturize( apply_filters( 'give_tributes_mail_card_notification_footer_text', '<a href="' . esc_url( home_url() ) . '">' . get_bloginfo( 'name' ) . '</a>' ) ) ) ); ?>
												</td>
											</tr>
										</table>
									</td>
								</tr>
							</table>
							<!-- End Footer -->
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</div>
</body>
</html>
